clc; clear all; close all;

load stress32p8kHzTF.mat
figure ('DefaultAxesFontSize',20); %hold on; box on;       
plot(z*1e3, s, 'k','LineWidth',4); hold on;
xlabel('z (mm)');
ylabel('First principal stress (Pa)');
xlim([z(1)*1e3 z(end)*1e3])
print ('-depsc2', 'stress32p8kHzTF.eps');
print -djpeg100 stress32p8kHzTF.jpg
print -dbmp stress32p8kHzTF.bmp


flload('fem_eigf32p8kHzTf.mph');

g  = 0.3e-3;
xr = g/2+2e-5;
zr = 3.75e-3;
g = 1;

x1 =  [0:(xr/g)/100:(xr/g)];
r  =  (xr/g)*ones(1,length(x1));
y1 =  0*ones(1,length(x1));
z1 = -sqrt(r.^2-x1.^2);

p  = [x1(:)';y1(:)';z1(:)'];
s1 = postinterp(fem, 's1_sld',  p);

z2 = [0:(zr/g)/100:zr/g];
x2 = (xr/g)*ones(1,length(z2));
y2 = 0*ones(1,length(x2));
p  = [x2(:)';y2(:)'; z2(:)'];

s2 = postinterp(fem, 's1_sld',  p);

z = [z1 z2];
s = [s1 s2];

% figure ('DefaultAxesFontSize',20); %hold on; box on;       
% plot(z*g*1e3, s/g, 'k','LineWidth',3); hold on;
% xlabel('z');
% ylabel('first principal stress');
% xlim([z(1)*g*1e3 z(end)*g*1e3])
% print ('-depsc2', 'stress32p8kHzTF.eps');
% print -djpeg100 stress32p8kHzTF.jpg
% print -dbmp stress32p8kHzTF.bmp

% figure versus angle
figure1 = figure('DefaultAxesFontSize',20);box on; hold on;
theta = atan2(x1,abs(z1))*180/pi;
plot(theta, s1/s1(1), 'k','LineWidth',4); hold on;
xlabel('\theta (degrees)');
ylabel(['Normalized first',sprintf('\n'),'principal stress'],'FontSize',20);
xlim([0 90]);
set(gca,'XTick',[0 30 60 90], 'fontsize', 20);
set(gca,'YTick',[1 1.3 1.6], 'fontsize', 20);
%legend3 = legend('Signal strength (pA)', '(x,z) position of the laser source');
%set(legend3,'FontSize',15,'FontName','Times New Roman');
print ('-depsc2', 'stress32p8kHzTF_angle.eps');
print -djpeg100 stress32p8kHzTF_angle.jpg

return;
