% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.608, $Date: 2009/05/11 07:38:49 $)
% Some geometry objects are stored in a separate file.
% The name of this file is given by the variable 'flbinaryfile'.

flclear fem

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 608;
vrsn.rcs = '$Name: v35ap $';
vrsn.date = '$Date: 2009/05/11 07:38:49 $';
fem.version = vrsn;

flbinaryfile='tmp.mphm';

% Constants
fem.const = {'l','0.00375', ...
  'radius','gap/2', ...
  'lt','l+radius+lb', ...
  'lb','0.00233', ...
  'width','0.0005999999999999999', ...
  'gap','0.3e-3', ...
  'thickness','0.00034', ...
  'rho_quartz','2650', ...
  'cp_quartz','733', ...
  'lam','1.55e-6', ...
  'W_L','50e-3', ...
  'c11','86.80e9', ...
  'c12','7.04e9', ...
  'c13','11.91e9', ...
  'c14','-18.04e9', ...
  'c33','105.75e9', ...
  'c44','58.20e9', ...
  'c66','39.88e9', ...
  'SCALE','1'};

% Geometry
clear draw
g5=flbinary('g5','draw',flbinaryfile);
draw.s.objs = {g5};
draw.s.name = {'CO1'};
draw.s.tags = {'g5'};
fem.draw = draw;
fem.geom = flbinary('g1','geom',flbinaryfile);
fem.mesh = flbinary('m1','mesh',flbinaryfile);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'FlSolid3';
appl.dim = {'u4','v4','w4'};
appl.gporder = 4;
appl.cporder = 2;
appl.assignsuffix = '_sld';
clear prop
prop.analysis='eigen';
appl.prop = prop;
clear bnd
bnd.Hy = {0,1};
bnd.Hx = {0,1};
bnd.Hz = {0,1};
bnd.ind = [1,1,2,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem, ...
                     'dofversion',1);

% Retrieve solution
fem.sol=flbinary('sol1','solution',flbinaryfile);

% Save current fem structure for restart purposes
fem0=fem;

% Plot solution
postplot(fem, ...
         'slicedata',{'mises_sld','cont','internal','unit','Pa'}, ...
         'slicexspacing',5, ...
         'sliceyspacing',0, ...
         'slicezspacing',0, ...
         'slicemap','Rainbow', ...
         'title','eigfreq_sld(1)=-2.121387e5i    Slice: von Mises stress [Pa]', ...
         'grid','on', ...
         'campos',[-0.016915429190141877,-0.02204461651309166,0.016677618828971834], ...
         'camtarget',[0,0,6.349999457597733E-4], ...
         'camup',[0,0,1], ...
         'camva',11.983287775671831);

% Plot solution
postplot(fem, ...
         'tetdata',{'s1_sld','cont','internal','unit','Pa'}, ...
         'tetmap','Rainbow', ...
         'tetkeep',1, ...
         'tetkeeptype','random', ...
         'title','eigfreq_sld(1)=-2.121387e5i    Subdomain: First principal stress [Pa]', ...
         'grid','on', ...
         'campos',[-0.016915429190141877,-0.02204461651309166,0.016677618828971834], ...
         'camtarget',[0,0,6.349999457597733E-4], ...
         'camup',[0,0,1], ...
         'camva',11.983287775671831);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hcurve',0.3);

% Refine mesh
fem.mesh=meshrefine(fem, ...
                    'mcase',0, ...
                    'rmethod','longest');

% Refine mesh
fem.mesh=meshrefine(fem, ...
                    'mcase',0, ...
                    'rmethod','longest');

% Refine mesh
fem.mesh=meshrefine(fem, ...
                    'mcase',0, ...
                    'rmethod','longest');

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hcurve',0.3);

% Refine mesh
fem.mesh=meshrefine(fem, ...
                    'mcase',0, ...
                    'rmethod','longest');

% Initialize mesh
fem.mesh=meshinit(fem);

% Refine mesh
fem.mesh=meshrefine(fem, ...
                    'mcase',0, ...
                    'rmethod','longest');

% Refine mesh
fem.mesh=meshrefine(fem, ...
                    'mcase',0, ...
                    'rmethod','longest');

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hcurve',0.3);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'FlSolid3';
appl.dim = {'u4','v4','w4'};
appl.gporder = 4;
appl.cporder = 2;
appl.assignsuffix = '_sld';
clear prop
prop.analysis='eigen';
appl.prop = prop;
clear bnd
bnd.Hy = {0,1};
bnd.Hx = {0,1};
bnd.Hz = {0,1};
bnd.ind = [1,1,2,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
fem.sol=femeig(fem, ...
               'solcomp',{'v4','u4','w4'}, ...
               'outcomp',{'v4','u4','w4'}, ...
               'blocksize','auto');

% Save current fem structure for restart purposes
fem0=fem;

% Plot solution
postplot(fem, ...
         'tetdata',{'s1_sld','cont','internal','unit','Pa'}, ...
         'tetmap','Rainbow', ...
         'tetkeep',1, ...
         'tetkeeptype','random', ...
         'solnum',1, ...
         'title','eigfreq_sld(1)=7967.404882    Subdomain: First principal stress [Pa]', ...
         'grid','on', ...
         'campos',[-0.016915429190141877,-0.02204461651309166,0.016677618828971837], ...
         'camtarget',[0,0,6.349999457597733E-4], ...
         'camup',[0,0,1], ...
         'camva',11.98328777567175);
