clc; clear all; close all;

load stress3kHzTF.mat;

figure ('DefaultAxesFontSize',20); %hold on; box on;       
plot(z*1e3, s, 'k','LineWidth',3); hold on;
xlabel('z');
ylabel('first principal stress');
xlim([z(1)*1e3 z(end)*1e3])
print ('-depsc2', 'stress3kHzTF.eps');
print -djpeg100 stress3kHzTF.jpg
%print -dbmp stress3kHzTF.bmp

return;
flload('fem_eigf3kHzTf.mph');

g  = 0.00018874;
xr = g/2+2e-5;
zr = 1e-3;
g = 1;

x1 =  [0:(xr/g)/100:(xr/g)];
r  =  (xr/g)*ones(1,length(x1));
y1 =  0*ones(1,length(x1));
z1 = -sqrt(r.^2-x1.^2);

p  = [x1(:)';y1(:)';z1(:)'];
s1 = postinterp(fem, 's1_sld',  p);

z2 = [0:(zr/g)/100:zr/g];
x2 = (xr/g)*ones(1,length(z2));
y2 = 0*ones(1,length(x2));
p  = [x2(:)';y2(:)'; z2(:)'];

s2 = postinterp(fem, 's1_sld',  p);

z = [z1 z2];
s = [s1 s2];

figure ('DefaultAxesFontSize',20); %hold on; box on;       
plot(z*g*1e3, s/g, 'k','LineWidth',3); hold on;
xlabel('z');
ylabel('first principal stress');
xlim([z(1)*g*1e3 z(end)*g*1e3])
print ('-depsc2', 'stress3kHzTF.eps');
print -djpeg100 stress3kHzTF.jpg
print -dbmp stress3kHzTF.bmp
