clc; clear all; close all;

k = 10^-5;
omega = 2*pi*32761;
beta = 7*10^-6;
CONST = 2*k*omega*beta*10^12;

load thdata_zs1.mat;
load thdata_zs2.mat;
load thdata_zs3.mat;

filename = sprintf('thdata_vertical.txt');
fid = fopen(filename, 'w');
if (fid == -1)
    error('error opening log file');
end;
fprintf(fid, '%s\n','   zs(m)    S1(pA)  phase1   S2(pA) phase2   S3(pA) phase3')
fprintf(fid, '%s\n','              xs = 0 mm      xs = 0.12 mm     xs = 0.13 mm')
for it = 1:5
        fprintf(fid, '%9.6f\t%6.2f\t%6.2f\t%6s\t%6s\t%6s\t%6s\n', ...
                   zs1(it), CONST*ampuzs1(it), thetauzs1(it), 'N/A', 'N/A', 'N/A', 'N/A');
end
jt = it+1;
for it = 1:10 %10
         fprintf(fid, '%9.6f\t%6.2f\t%6.2f\t%6.2f\t%6.2f\t%6s\t%6s\n', ...
                   zs1(jt), CONST*ampuzs1(jt), thetauzs1(jt), ...
                            CONST*ampuzs2(it), thetauzs2(it),...
                            'N/A', 'N/A');
        jt = jt+1;
       
end
it = it+1;

for kt = 1:length(zs3)
       fprintf(fid, '%9.6f\t%6.2f\t%6.2f\t%6.2f\t%6.2f\t%6.2f\t%6.2f\n', ...
                   zs1(jt), CONST*ampuzs1(jt), thetauzs1(jt), ...
                            CONST*ampuzs2(it), thetauzs2(it), ...
                            CONST*ampuzs3(kt), thetauzs3(kt));
        jt = jt+1;
        it = it+1;
end
fclose(fid); 

figure('DefaultAxesFontSize',16);box on;
plot(zs1*1e3, CONST*ampuzs1,'ro','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs2*1e3, CONST*ampuzs2,'MarkerFaceColor',[0 0 1], ...
                            'LineWidth',2,...
                            'LineStyle','none',...
                            'Marker','diamond',...
                            'MarkerSize', 7); hold on;
plot(zs3*1e3, CONST*ampuzs3,'Color',[0 0.498039215686275 0], ...
                            'LineWidth',2,...
                            'LineStyle','none',...
                            'Marker','s',...
                            'MarkerSize', 7); hold on;                        
%title('ROTADE');
xlabel('z (mm)');
ylabel('S (pA)');
legend1 = legend('S1(pA) - 0.15 mm, center', 'S2(pA) - 0.03 mm', 'S3(pA) - 0.02 mm');
set(legend1,'FontSize',15,'FontName','Times New Roman');
xlim([-0.2 1]);
print ('-depsc2', 'verticalsignal.eps');
print -djpeg100 verticalsignal.jpg
print -dbmp verticalsignal.bmp

figure('DefaultAxesFontSize',16);box on;
plot(zs1*1e3, thetauzs1,'ro','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs2*1e3, thetauzs2,'MarkerFaceColor',[0 0 1], ...
                            'LineWidth',2,...
                            'LineStyle','none',...
                            'Marker','diamond',...
                            'MarkerSize', 7); hold on;
plot(zs3*1e3, thetauzs3,'Color',[0 0.498039215686275 0], ...
                            'LineWidth',2,...
                            'LineStyle','none',...
                            'Marker','s',...
                            'MarkerSize', 7); hold on;                           
%title('ROTADE');
xlabel('z (mm)');
ylabel('Phase (degrees)');
legend2 = legend('Phase1 - 0.15 mm, center', 'Phase2 - 0.03 mm', 'Phase3 - 0.02 mm', 'Location','Best');
set(legend2,'FontSize',15,'FontName','Times New Roman');
xlim([-0.2 1]);
print ('-depsc2', 'verticalphase.eps');
print -djpeg100 verticalphase.jpg
print -dbmp verticalphase.bmp

load thdata_zs5.mat;
x1 = xs5*1e3;
y1 = CONST*ampuzs5;
x2 = x1; 
y2 = zs5*1e3;

filename = sprintf('thdata_horizontal.txt');
fid = fopen(filename, 'w');
if (fid == -1)
    error('error opening log file');
end;
fprintf(fid, '%s\n','   xs(m)       zs(m)     S(pA)   phase')
for it = 1:length(zs5)
    fprintf(fid, '%9.6f\t%9.6f\t%6.2f\t%6.2f\n', ...
                   xs5(it), zs5(it), CONST*ampuzs5(it), thetauzs5(it));
end
fclose(fid);

figure1 = figure('DefaultAxesFontSize',16);box on; hold on;
[AX,H1,H2] = plotyy(x1,y1,x1,y2,'plot');
set(get(AX(1),'Ylabel'),'String','S(pA)', 'FontSize',16) 
set(get(AX(2),'Ylabel'),'String','z (mm)', 'FontSize',16, 'Position', [0.15 -0.0755 17.32]) 
set(H1,'MarkerSize',7,'Marker','o','LineWidth',2.5,'Color','r')
set(H2,'MarkerSize',7,'Marker','diamond', 'MarkerFaceColor',[0 0 1],'LineWidth',2.5,'Color','b');
set(get(AX(1),'XLabel'),'Color','k');
xlim(AX(1),[0 0.14]);
xlim(AX(2),[0 0.14]);
set(get(AX(1),'YLabel'),'Color','k');
set(get(AX(2),'YLabel'),'Color','k');
set(AX(1),'XColor','k','YColor','k');
set(AX(2),'YColor','k');
%title('ROTADE');
xlabel('x (mm)');
legend3 = legend('S (pA)', 'z (mm)');
set(legend3,'FontSize',15,'FontName','Times New Roman', ...
             'Position', [0.15 0.75 0.2 0.15]);
print ('-depsc2', 'horizontalsignal.eps');
print -djpeg100 horizontalsignal.jpg
print -dbmp horizontalsignal.bmp

figure('DefaultAxesFontSize',16);box on; hold on;
plot([xs5*1e3], [thetauzs5], 'MarkerSize',7,'Marker','o','LineWidth',2.5,'Color','r');
%title('ROTADE');
xlabel('x (mm)');
ylabel('Phase (degrees)');
xlim([0 0.131]);
print -djpeg100 horizontalphase.jpg
print ('-depsc2', 'horizontalphase.eps');
print -dbmp horizontalphase.bmp