clc; clear all; close all;

k = 0.04986/2;
omega = 2*pi*32761;
beta = 7*10^-6;
CONST = 2*k*omega*beta*10^12

importfile1('rotade20100325_1DscanCO2_20torr.txt');
expconst = 6.6677e-015*1e12;
exppos_CO2at20torr = rotade20100325_1DscanCO2_20torr(:,1)-1.88;
LockInX            = rotade20100325_1DscanCO2_20torr(:,2);
LockInY            = rotade20100325_1DscanCO2_20torr(:,3);
tempVec            = complex(LockInX,LockInY);
R_CO2              = abs(tempVec);
theta_CO2          = angle(tempVec);
expPhase_CO2at20torr  = theta_CO2*(180/pi);
expSignal_CO2at20torr = R_CO2*expconst;

importfile2('rotade_Acetylene1dScan_20torr.txt');
exppos_acet_20torr    = rotade_Acetylene1dScan_20torr(:,1)-2;
R_acet_20torr         = rotade_Acetylene1dScan_20torr(:,5);
theta_acet_20torr     = rotade_Acetylene1dScan_20torr(:,6);
expSignal_acet_20torr = R_acet_20torr*expconst; % units of picoA
expPhase_acet_20torr  = theta_acet_20torr*(180/pi);

load thdata_zs1_CO2at20Torr.mat;
ampuzs1CO2at20Torr = ampuzs1;
phaseCO2at20Torr   = thetauzs1;

load thdata_zs1_N2at20Torr.mat;
ampuzs1Nat20Torr = ampuzs1;
phaseNat20Torr   = thetauzs1;

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YScale','log','YMinorTick','on','XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.2+0.15 0.81+0.15]);
box(axes1,'on');
hold(axes1,'all');
x = [0.02:(0.15-0.02)/30:0.15];
m = (-2.62);
y = m*x+(m*(-0.05)+3.58);
semilogy(x, 10.^y,'r','LineWidth',2.5, 'MarkerSize', 6); hold on;
semilogy(zs1*1e3+0.15, CONST*ampuzs1Nat20Torr*4*10^-3,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
legend('Theory (20 Torr)');
xlabel('Source position');
ylabel('Normalized signal strength');

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YScale','log','YMinorTick','on','XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.2+0.15 0.81+0.15]);
box(axes1,'on');
hold(axes1,'all');
x = [0.02:(0.15-0.02)/30:0.15];
m = (-2.15);
y = m*x+(m*(-0.06)+3.53);
semilogy(x, 10.^y,'r','LineWidth',2.5, 'MarkerSize', 6); hold on;
semilogy(exppos_acet_20torr, expSignal_acet_20torr,'bo','LineWidth',2.5, 'MarkerSize', 5)
legend('Exp (20 Torr)');%'2e-3*theory 10 torr','3.8e-3*theory 20 torr'
xlabel('Source position');
ylabel('Normalized signal strength');

% PHASE - theory versus experiment
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([0 0.5]);
box(axes1,'on');
hold(axes1,'all');
x = [0.02:(0.15-0.02)/30:0.15];
m = -470;
y = m*x+(m*(-0.05)+140);
plot(x, y,'r','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3+0.15, phaseNat20Torr,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
legend('Theory (20 Torr)',4);   
xlabel('Source position (mm)');
ylabel('Phase (degrees)');

% PHASE - theory versus experiment
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([0 0.5]);
box(axes1,'on');
hold(axes1,'all');
x = [0.02:(0.15-0.02)/30:0.15];
m = -360;
y = m*x+(m*(-0.05)+140);
plot(x, y,'r','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(exppos_acet_20torr, expPhase_acet_20torr+180+40+10,'bo','LineWidth',2.5, 'MarkerSize', 5)
legend('Exp-30 (20 Torr)', 4);   
xlabel('Source position (mm)');
ylabel('Phase (degrees)');