clc; clear all; close all;

k = 0.04986/2;
omega = 2*pi*32761;
beta = 7*10^-6;
CONST = 2*k*omega*beta*10^12

importfile1('rotade20100325_1DscanCO2_20torr.txt');
expconst = 6.6677e-015*1e12;
exppos_CO2at20torr = rotade20100325_1DscanCO2_20torr(:,1)-1.88;
LockInX            = rotade20100325_1DscanCO2_20torr(:,2);
LockInY            = rotade20100325_1DscanCO2_20torr(:,3);
tempVec            = complex(LockInX,LockInY);
R_CO2              = abs(tempVec);
theta_CO2          = angle(tempVec);
expPhase_CO2at20torr  = theta_CO2*(180/pi);
expSignal_CO2at20torr = R_CO2*expconst;

importfile2('rotade_Acetylene1dScan_5torr.txt');
exppos_acet_5torr    = rotade_Acetylene1dScan_5torr(:,1)-2;
R_acet_5torr         = rotade_Acetylene1dScan_5torr(:,5);
theta_acet_5torr     = rotade_Acetylene1dScan_5torr(:,6);
expSignal_acet_5torr = R_acet_5torr*expconst; % units of picoA
expPhase_acet_5torr  = theta_acet_5torr*(180/pi);

importfile2('rotade_Acetylene1dScan_10torr.txt');
exppos_acet_10torr    = rotade_Acetylene1dScan_10torr(:,1)-2;
R_acet_10torr         = rotade_Acetylene1dScan_10torr(:,5);
theta_acet_10torr     = rotade_Acetylene1dScan_10torr(:,6);
expSignal_acet_10torr = R_acet_10torr*expconst; % units of picoA
expPhase_acet_10torr  = theta_acet_10torr*(180/pi);

importfile2('rotade_Acetylene1dScan_20torr.txt');
exppos_acet_20torr    = rotade_Acetylene1dScan_20torr(:,1)-2;
R_acet_20torr         = rotade_Acetylene1dScan_20torr(:,5);
theta_acet_20torr     = rotade_Acetylene1dScan_20torr(:,6);
expSignal_acet_20torr = R_acet_20torr*expconst; % units of picoA
expPhase_acet_20torr  = theta_acet_20torr*(180/pi);

load thdata_zs1_CO2at5Torr.mat;
ampuzs1CO2at5Torr = ampuzs1;
phaseCO2at5Torr   = thetauzs1;
realuzs1CO2at5Torr= realuzs1;
imaguzs1CO2at5Torr= imaguzs1;
complxval1 = i*(realuzs1CO2at5Torr+i*imaguzs1CO2at5Torr);
complxval2 = -imaguzs1CO2at5Torr+i*realuzs1CO2at5Torr;
phaseCO2at5Torr2 = atan2(imag(complxval2), real(complxval2))*180/pi;

load thdata_zs1_CO2at10Torr.mat;
ampuzs1CO2at10Torr = ampuzs1;
phaseCO2at10Torr   = thetauzs1;
 
load thdata_zs1_CO2at20Torr.mat;
ampuzs1CO2at20Torr = ampuzs1;
phaseCO2at20Torr   = thetauzs1;
realuzs1CO2at20Torr= realuzs1;
imaguzs1CO2at20Torr= imaguzs1;
complxval1 = i*(realuzs1CO2at20Torr+i*imaguzs1CO2at20Torr);
complxval2 = -imaguzs1CO2at20Torr+i*realuzs1CO2at20Torr;
phaseCO2at20Torr2 = atan2(imag(complxval2), real(complxval2))*180/pi;

load thdata_zs1_N2at5Torr.mat;
ampuzs1Nat5Torr = ampuzs1;
phaseNat5Torr   = thetauzs1;

load thdata_zs1_N2at10Torr.mat;
ampuzs1Nat10Torr = ampuzs1;
phaseNat10Torr   = thetauzs1;

load thdata_zs1_N2at20Torr.mat;
ampuzs1Nat20Torr = ampuzs1;
phaseNat20Torr   = thetauzs1;

% % AMPLITUDE - theory 
% figure1 = figure('DefaultAxesFontSize',20);
% % Create axes
% axes1 = axes('Parent',figure1,'YScale','log','YMinorTick','on','XTick',[0 0.4 0.8],...
%     'FontSize',20);
% xlim([-0.2 0.81]);
% box(axes1,'on');
% hold(axes1,'all');
% semilogy(zs1*1e3, CONST*ampuzs1Nat20Torr*4*10^-3,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
% legend('Theory (20 Torr)');
% xlabel('Source position');
% ylabel('Normalized signal strength');
% 
% % AMPLITUDE - theory 
% figure1 = figure('DefaultAxesFontSize',20);
% % Create axes
% axes1 = axes('Parent',figure1,'YScale','log','YMinorTick','on','XTick',[0 0.4 0.8],...
%     'FontSize',20);
% xlim([-0.2 0.81]);
% box(axes1,'on');
% hold(axes1,'all');
% semilogy(exppos_acet_20torr-0.15, expSignal_acet_20torr,'bo','LineWidth',2.5, 'MarkerSize', 5)
% legend('Exp (20 Torr)');%'2e-3*theory 10 torr','3.8e-3*theory 20 torr'
% xlabel('Source position');
% ylabel('Normalized signal strength');
% 

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YTick',[0.2 0.6 1],'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.2 0.81]);
box(axes1,'on');
hold(axes1,'all');
%plot(zs1*1e3, CONST*ampuzs1CO2at5Torr/max(CONST*ampuzs1CO2at5Torr), 'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
%plot(zs1*1e3, CONST*ampuzs1CO2at10Torr/max(CONST*ampuzs1CO2at10Torr),'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, CONST*ampuzs1CO2at20Torr/max(CONST*ampuzs1CO2at20Torr),'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(exppos_CO2at20torr-0.15, expSignal_CO2at20torr/max(expSignal_CO2at20torr),'bo','LineWidth',2.5, 'MarkerSize', 5)
% legend('Theory (5 Torr)','Theory (10 Torr)','Theory (20 Torr)',...
%        'Exp (20 Torr)'); %'3.2e-4*theory 20 torr'
legend('Theory',...
       'Experiment'); %'3.2e-4*theory 20 torr'
xlabel('z (mm)');
ylabel('Normalized signal strength');
%title('Theory vs experiment for CO_2')
print ('-depsc2', 'ampthVSexpCO2.eps');
print -djpeg100 ampthVSexpCO2.jpg

% PHASE - theory versus experiment
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YTick',[-150 -50],'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.15 0.81]);
box(axes1,'on');
hold(axes1,'all');
%plot(zs1*1e3, -phaseCO2at5Torr,'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
%plot(zs1*1e3, -phaseCO2at10Torr,'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, -phaseCO2at20Torr,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(exppos_CO2at20torr-0.15, expPhase_CO2at20torr-30,'bo','LineWidth',2.5, 'MarkerSize', 5)
% legend('Theory (5 Torr)','Theory (10 Torr)','Theory (20 Torr)',...
%        'Exp-30 (20 Torr)', 4);
legend('Theory',...
       'Experiment', 4);   
xlabel('z (mm)');
ylabel('Phase (degrees)');
%title('Theory vs experiment for CO_2');
print ('-depsc2', 'phasethVSexpCO2.eps');
print -djpeg100 phasethVSexCO2.jpg
%print -dbmp fVSl.bmp

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YTick',[0.2 0.6 1],'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.2 0.81]);
box(axes1,'on');
hold(axes1,'all');
%plot(zs1*1e3, CONST*ampuzs1Nat5Torr/max(CONST*ampuzs1Nat5Torr), 'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, CONST*ampuzs1Nat10Torr/max(CONST*ampuzs1Nat10Torr),'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, CONST*ampuzs1Nat20Torr/max(CONST*ampuzs1Nat20Torr),'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
%plot(exppos_acet_5torr-0.15, expSignal_acet_5torr/max(expSignal_acet_5torr),'kv','LineWidth',2.5, 'MarkerSize', 5)
plot(exppos_acet_10torr-0.15, expSignal_acet_10torr/max(expSignal_acet_10torr),'rs','LineWidth',2.5, 'MarkerSize', 5)
plot(exppos_acet_20torr-0.15, expSignal_acet_20torr/max(expSignal_acet_20torr),'bo','LineWidth',2.5, 'MarkerSize', 5)
% legend('Theory (5 Torr)','Theory (10 Torr)','Theory (20 Torr)',...
%        'Exp (5 Torr)', 'Exp (10 Torr)','Exp (20 Torr)');%'2e-3*theory 10 torr','3.8e-3*theory 20 torr'
legend('Theory (10 Torr)','Theory (20 Torr)',...
       'Exp (10 Torr)','Exp (20 Torr)');%'2e-3*theory 10 torr','3.8e-3*theory 20 torr'
xlabel('z (mm)');
ylabel('Normalized signal strength');
%title('Theory vs experiment for N_2')
print ('-depsc2', 'ampthVSexpN2.eps');
print -djpeg100 ampthVSexpN2.jpg

figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YTick',[100 140 180], 'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.15 0.61-0.15]);
box(axes1,'on');
hold(axes1,'all');
%plot(zs1*1e3, phaseNat5Torr,'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, phaseNat10Torr,'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, phaseNat20Torr,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
%plot(exppos_acet_5torr-0.15, expPhase_acet_5torr+180+40+10,'kv','LineWidth',2.5, 'MarkerSize', 5);
plot(exppos_acet_10torr-0.15, expPhase_acet_10torr+180+40+10,'rs','LineWidth',2.5, 'MarkerSize', 5);
plot(exppos_acet_20torr-0.15, expPhase_acet_20torr+180+40+10,'bo','LineWidth',2.5, 'MarkerSize', 5)
legend('Theory (10 Torr)',...
       'Theory (20 Torr)',...
       'Exp (10 Torr)', ...
       'Exp (20 Torr)',1);
xlabel('z (mm)');
ylabel('Phase');
%title('Theory vs experiment for N_2')
print ('-depsc2', 'phasethVSexpN2.eps');
print -djpeg100 phasethVSexpN2.jpg

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YTick',[0.2 0.6 1],'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.16 0.81]);
box(axes1,'on');
hold(axes1,'all');
plot(zs1*1e3, CONST*ampuzs1CO2at5Torr/max(CONST*ampuzs1CO2at5Torr), 'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, CONST*ampuzs1CO2at10Torr/max(CONST*ampuzs1CO2at10Torr),'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
%plot(zs1*1e3, CONST*ampuzs1CO2at15Torr/max(CONST*ampuzs1CO2at15Torr),'y-d','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, CONST*ampuzs1CO2at20Torr/max(CONST*ampuzs1CO2at20Torr),'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
legend('Theory (5 Torr)','Theory (10 Torr)','Theory (20 Torr)');
xlabel('z (mm)');
ylabel('Normalized signal strength');
%title('Theory vs experiment for N_2')
print ('-depsc2', 'ampthCO2.eps');
print -djpeg100 ampthCO2.jpg

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
% Create axes
axes1 = axes('Parent',figure1,'YScale','log','YMinorTick','on',...
    'XTick',[0 0.4 0.8],...
    'FontSize',20);
% Uncomment the following line to preserve the X-limits of the axes
xlim(axes1,[-0.15 0.81]);
box(axes1,'on');
hold(axes1,'all');
semilogy(zs1*1e3, CONST*ampuzs1CO2at5Torr, 'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
semilogy(zs1*1e3, CONST*ampuzs1CO2at10Torr,'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
%semilogy(zs1*1e3, CONST*ampuzs1CO2at15Torr,'y-d','LineWidth',2.5, 'MarkerSize', 6); hold on;
semilogy(zs1*1e3, CONST*ampuzs1CO2at20Torr,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
legend('Theory (5 Torr)','Theory (10 Torr)','Theory (20 Torr)');
xlabel('z (mm)');
ylabel('Signal strength');
print ('-depsc2', 'ampthCO2log.eps');
print -djpeg100 ampthCO2log.jpg

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'YTick',[0.2 0.6 1],'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.16 0.81]);
box(axes1,'on');
hold(axes1,'all');
plot(zs1*1e3, CONST*ampuzs1Nat5Torr/max(CONST*ampuzs1Nat5Torr), 'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, CONST*ampuzs1Nat10Torr/max(CONST*ampuzs1Nat10Torr),'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(zs1*1e3, CONST*ampuzs1Nat20Torr/max(CONST*ampuzs1Nat20Torr),'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
legend('Theory (5 Torr)','Theory (10 Torr)','Theory (20 Torr)');
xlabel('z (mm)');
ylabel('Normalized signal strength');
print ('-depsc2', 'ampthN2.eps');
print -djpeg100 ampthN2.jpg

% AMPLITUDE - theory 
figure1 = figure('DefaultAxesFontSize',20);
axes1 = axes('Parent',figure1,'YScale','log','YMinorTick','on',...
    'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim(axes1,[-0.15 0.81]);
ylim(axes1,[1e4 1e7]);
box(axes1,'on');
hold(axes1,'all');
semilogy(zs1*1e3, CONST*ampuzs1Nat5Torr, 'k-v','LineWidth',2.5, 'MarkerSize', 6); hold on;
semilogy(zs1*1e3, CONST*ampuzs1Nat10Torr,'r-s','LineWidth',2.5, 'MarkerSize', 6); hold on;
semilogy(zs1*1e3, CONST*ampuzs1Nat20Torr,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
legend('Theory (5 Torr)','Theory (10 Torr)','Theory (20 Torr)', 3);
xlabel('z (mm)');
ylabel('Signal strength');
print ('-depsc2', 'ampthN2log.eps');
print -djpeg100 ampthN2log.jpg

