clc; clear all; close all;

k     = 0.04986/2;
omega = 2*pi*32761;
beta  = 7*10^-6;
CONST = 2*k*omega*beta*10^12

importfile1('rotade20100325_1DscanCO2_20torr.txt');
expconst = 6.6677e-015*1e12;
exppos_CO2at20torr    = rotade20100325_1DscanCO2_20torr(:,1)-1.88;
LockInX               = rotade20100325_1DscanCO2_20torr(:,2);
LockInY               = rotade20100325_1DscanCO2_20torr(:,3);
tempVec               = complex(LockInX,LockInY);
R_CO2                 = abs(tempVec);
theta_CO2             = angle(tempVec);
expPhase_CO2at20torr  = theta_CO2*(180/pi);
expSignal_CO2at20torr = R_CO2*expconst;

importfile2('rotade_Acetylene1dScan_5torr.txt');
exppos_acet_5torr    = rotade_Acetylene1dScan_5torr(:,1)-2;
R_acet_5torr         = rotade_Acetylene1dScan_5torr(:,5);
theta_acet_5torr     = rotade_Acetylene1dScan_5torr(:,6);
expSignal_acet_5torr = R_acet_5torr*expconst; % units of picoA
expPhase_acet_5torr  = theta_acet_5torr*(180/pi);

importfile2('rotade_Acetylene1dScan_10torr.txt');
exppos_acet_10torr    = rotade_Acetylene1dScan_10torr(:,1)-2;
R_acet_10torr         = rotade_Acetylene1dScan_10torr(:,5);
theta_acet_10torr     = rotade_Acetylene1dScan_10torr(:,6);
expSignal_acet_10torr = R_acet_10torr*expconst; % units of picoA
expPhase_acet_10torr  = theta_acet_10torr*(180/pi);

importfile2('rotade_Acetylene1dScan_20torr.txt');
exppos_acet_20torr    = rotade_Acetylene1dScan_20torr(:,1)-2;
R_acet_20torr         = rotade_Acetylene1dScan_20torr(:,5);
theta_acet_20torr     = rotade_Acetylene1dScan_20torr(:,6);
expSignal_acet_20torr = R_acet_20torr*expconst; % units of picoA
expPhase_acet_20torr  = theta_acet_20torr*(180/pi);
 
load thdata_zs1_CO2at20Torr.mat;
ampuzs1CO2at20Torr = ampuzs1;
phaseCO2at20Torr   = thetauzs1;
realuzs1CO2at20Torr= realuzs1;
imaguzs1CO2at20Torr= imaguzs1;
complxval1 = i*(realuzs1CO2at20Torr+i*imaguzs1CO2at20Torr);
complxval2 = -imaguzs1CO2at20Torr+i*realuzs1CO2at20Torr;
phaseCO2at20Torr2 = atan2(imag(complxval2), real(complxval2))*180/pi;

load thdata_zs1_N2at20Torr.mat;
ampuzs1Nat20Torr   = ampuzs1;
phaseNat20Torr     = thetauzs1;
realuzs1N2at20Torr = realuzs1;
imaguzs1N2at20Torr = imaguzs1;
complxval1 = i*(realuzs1N2at20Torr+i*imaguzs1N2at20Torr);
phaseN2at20Torr2 = atan2(imag(complxval1), real(complxval1))*180/pi;
phaseN2at20Torr3 = (atan2(imaguzs1, realuzs1)-pi/2)*180/pi;
max(abs(phaseN2at20Torr2-phaseN2at20Torr3))
figure1 = figure('DefaultAxesFontSize',20);
% Create axes
axes1 = axes('Parent',figure1,'XTick',[0 0.4 0.8],...
    'FontSize',20);
xlim([-0.15 0.61-0.15]);
box(axes1,'on');
hold(axes1,'all');
plot(zs1*1e3,                 phaseN2at20Torr3,'b-o','LineWidth',2.5, 'MarkerSize', 6); hold on;
plot(exppos_acet_20torr-0.15, expPhase_acet_20torr+140,'bo','LineWidth',2.5, 'MarkerSize', 5)
legend('Theory (10 Torr)',...
       'Theory (20 Torr)', ...
       'Exp+230 (10 Torr)', ...
       'Exp+230 (20 Torr)', 1);
xlabel('Source position (mm)');
ylabel('Phase');
% %title('Theory vs experiment for N_2')
% print ('-depsc2', 'phasethVSexpN2.eps');
% print -djpeg100 phasethVSexpN2.jpg

