function [fx, cx] = rotade(u);

fclose('all');

% Print the computed values:
fidhistory = fopen('history_debug.txt', 'a+');
if (fidhistory == -1)
  error('error opening log file');
end;

fprintf(fidhistory, 'NOMADm starts l = %23.16e g = %23.16e zs = %23.16e \n', u(1), u(3), -(u(3)/2-0.02e-3));
%fprintf(fidhistory, 'NOMADm starts l = %23.16e g = %23.16e zs = %23.16e \n', u(1), u(2), u(3));

% give the number of refinments
nrefT1 = 4;
nrefT2 = 4;
nrefD  = 2;
nreigs = 6;

% l w g lb t
% give the dimensions of the tuning fork
l         = u(1);
g         = 0.3e-3; %this will not change the geom but the scaling factor!
lb        = u(4); %0.00233; %u(2);
t         = u(5); %0.34e-3; %u(3);
w         = u(2); %0.6e-3; %u(4);

w0  = 7.5e-6;
lam = 1.55e-6;
yR  = pi*w0^2/lam;
a   = u(3);   

% give the position of the laser beam

xs = 0;
ys = 0;
zs = -(u(3)/2-0.02e-3);
fprintf(fidhistory, 'Before COMSOL for: l = %9.6f lb = %9.6f t = %9.6f w = %9.6f g = %9.6f zs = %23.16e \n', l, lb, t, w, a, zs);
fclose(fidhistory); 


[f, nreigf] = rotade3D_eigenmodes(3, a, l/a, lb/a, w/a, t/a);

if (f < 30000 || f > 34000)
    ampu = inf;	
    eigf_res = f;
    epskappa = 0;
    fx = eigf_res*ampu;
else
    % setup the boundary condition for the second stage heat problem
    T2D_boundarydata_SCALEDeq(a, w/a, t/a, w0/a, yR/a, f);

    % compute the signal strength
    [ ampu, eigf_res, epskappa ]  = rotade3D_SCALEDeq(xs/a, ys/a, zs/a, nrefT1, nrefT2, nrefD, nreigs, a, l/a, lb/a, w/a, t/a, w0/a, yR/a, f, nreigf);
    fx = eigf_res*ampu;
end

% apply the constraint on the resonance frequency
%cx = [];
cx(1) = eigf_res/34000-1;
cx(2) = 1-eigf_res/30000;

fIDs = fopen('all');
if (fIDs ~= 0)
	fprintf('testing the print out! length(fIDs) = %2d \n', length(fIDs));
end
return
