% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.603, $Date: 2008/12/03 17:02:19 $)
function  [realu, imagu , ampu , thetau] = rotade_matlab(xs, ys, zs, nrefT1, nrefT2, nrefD)

if (exist('fem0','var')), clear fem0 ; end;
if (exist('fem1','var')), clear fem1 ; end;
if (exist('fem2','var')), clear fem2 ; end;
if (exist('fem','var')),  clear fem ; end;

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 603;
vrsn.rcs = '$Name:  $';
vrsn.date = '$Date: 2008/12/03 17:02:19 $';
fem.version = vrsn;

% Geometry
% Import CAD data
garr = geomimport('/home/znoemi1/scratch/rotade/cadfiles/geometry.mphbin', ...
                  'repairtol','1.0E-5', ...
                  'sdim',3);
[g1]=deal(garr{:});

% Constants
fem.const = {'omega','2*pi*33815.20', ...
  'xs',xs, ...
  'ys',ys, ...
  'zs',zs, ...
  'rho_quartz','2650', ...
  'cp_quartz','733', ...
  'rho_CO2','0.047850', ...
  'cp_CO2','0.84081e3', ...
  'K_CO2','0.016346', ...
  'c_CO2','K_CO2/(rho_CO2*cp_CO2)', ...
  'K1_q','6.5', ...
  'K2_q','6.5', ...
  'K3_q','11.3', ...
  'c1_q','K1_q/(rho_quartz*cp_quartz)', ...
  'c2_q','K2_q/(rho_quartz*cp_quartz)', ...
  'c3_q','K3_q/(rho_quartz*cp_quartz)', ...
  'w0','7.5e-6', ...
  'lam','1.55e-6', ...                        
  'W_L', '30e-3',...
  'rho_quartz','2650', ...
  'c11','86.80e9', ...
  'c12','7.04e9', ...
  'c13','11.91e9', ...
  'c14','-18.04e9', ...
  'c33','105.75e9', ...
  'c44','58.20e9', ...
  'c66','39.88e9',...
   'b','-8.078e+006',...
   'b_quartz', '-1.622e+012'};

fem.globalexpr = {'yR','pi*w0^2/lam', ...
  'wy','w0*sqrt(1+(y/yR)^2)', ...
  'A_CO2p','(1/(rho_CO2*cp_CO2))*(2*W_L/pi)', ...        %!!! this does not inlcude the abs coeff
  'A_qzp', '(1/(rho_quartz*cp_quartz))*(2*W_L/pi)', ...  %!!! this does not inlcude the abs coeff
  'source_CO2','(A_CO2p/wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)', ...
  'source_qz', '(A_qzp/wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)', ...
  'I','2*W_L/(pi*wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)'};

% Geometry

% Analyzed geometry
clear s
s.objs={g1};
s.name={'CO1'};
s.tags={'g1'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',5);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.sshape = 2;
appl.assignsuffix = '_hzeq';
clear bnd
bnd.r = {0,0,'boundaryT(x-xs,z-zs)'};
bnd.type = {'dir','neu','dir'};
bnd.ind = [1,3,1,1,3,2,2,2,2,2,2,2,2,2,2,2,1];
appl.bnd = bnd;
clear equ
equ.f = {'source_CO2','source_qz'};
equ.c = {'c_CO2',{{'c1_q';'c2_q';'c3_q'}}};
equ.a = {'i*omega+b/(rho_CO2*cp_CO2)','i*omega+b_quartz/(rho_quartz*cp_quartz)'};
equ.ind = [1,2];
appl.equ = equ;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Descriptions
clear descr
descr.const= {'c33','N/m^2','E','Youngs modulus [Pa]','c2_q','m^2/s','c44','N/m^2','K3_q','J/(m s K)','c66','N/m^2','mu','Poisson ratio','K_CO2','thermal conduction (W/(mK))','rho_quartz','density of quartz [kg/m^3]','omega','angular frequency [1/s]','c_CO2','diffusion coefficient [m^2/s]','c3_q','m^2/s','cp_quartz','specific heat for quartz  J/(kgK)','sigma','beam width [m]','c1_q','m^2/s','rho_CO2','density of air [kg/m^3]','cp_CO2','specific heat for air  J/(kgK)','K2_q','J/(m s K)','c11','N/m^2','c13','N/m^2','c12','N/m^2','K1_q','J/(m s K)','c14','N/m^2'};
fem.descr = descr;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
tic;
%fem=adaption(fem, ...
%             'solcomp',{'u'}, ...
%             'outcomp',{'u'}, ...
%             'blocksize','auto', ...
%             'solver','stationary', ...
%             'eigselect',1, ...
%             'maxt',10000000, ...
%             'ngen',nrefT1, ...
%             'rmethod','longest', ...
%             'resorder','auto', ...
%             'eefun','l2', ...
%             'l2scale',1, ...
%             'l2staborder',2, ...
%             'tppar',1.1, ...
%	         'linsolver','gmres', ...
%             'itol',1.0E-8, ...
%             'prefun','ssor', ...
%             'geomnum',1);
fem=adaption(fem, ...
             'solcomp',{'u'}, ...
             'outcomp',{'u'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',nrefT1, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.1, ...
             'linsolver','pardiso', ...
             'geomnum',1);

tsec = toc;

% obtain statistics about the mesh
filename = sprintf('statistics_T1.txt');
fid = fopen(filename, 'a+');
if (fid == -1)
  error('error opening log file');
end;
% obain mesh and FEM statistics:
N_e = size(fem.mesh.t,2); % number of mesh elements
N_p = size(fem.mesh.p,2); % number of points, i.e., vertices
ndofs = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented
fprintf(fid, '%9.6f %4d %7d %7d %7d %7.2f\n', ...
     zs, nrefT1, N_e, N_p, ndofs, tsec/60);
fclose(fid); 

%flsave T1 fem;

%x = [0:0.15e-3/100:0.15e-3];
%y = zeros(1, length(x));
%z = zs*ones(1, length(x));
%p = [x(:)';y(:)'; z(:)'];
%T1 = postinterp(fem, 'abs(u)', p);
%save data1 'x' 'T1'

%x = [0.15e-3:(0.4e-3- 0.15e-3)/100:0.4e-3];
%y = zeros(1, length(x));
%z = zs*ones(1, length(x));
%p = [x(:)';y(:)'; z(:)'];
%T12 = postinterp(fem, 'abs(u)', p);
%save data12 'x' 'T12'

% Store solution
fem1 = fem;

% Geometry
% Import CAD data
garr = geomimport('/home/znoemi1/scratch/rotade/cadfiles/3DTF.mphbin', ...
                  'repairtol','1.0E-5', ...
                  'sdim',3);
[g2]=deal(garr{:});

% Analyzed geometry
clear s
s.objs={g2};
s.name={'CO1'};
s.tags={'g2'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',3);

% Refine mesh
% for it = 1:nrefT2
% fem.mesh=meshrefine(fem, ...
%                     'mcase',0, ...
%                     'rmethod','longest');
% end
% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'dir';
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'Helmholtz';
appl.dim = {'u2'};
appl.name = 'hzeq2';
appl.sshape = 2;
appl.assignsuffix = '_hzeq2';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.r = {0,'u'};
bnd.type = 'dir';
bnd.ind = [1,2,1,2,2,2,2,2,2,2,1];
appl.bnd = bnd;
clear equ
equ.f = 0;
equ.c = {{{'c1_q';'c2_q';'c3_q'}}};
equ.a = {'i*omega+b_quartz/(rho_quartz*cp_quartz)'};
equ.ind = [1];
appl.equ = equ;
fem.appl{2} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Descriptions
clear descr
descr.const= {'c33','N/m^2','E','Youngs modulus [Pa]','c2_q','m^2/s','c44','N/m^2','K3_q','J/(m s K)','c66','N/m^2','mu','Poisson ratio','K_CO2','thermal conduction (W/(mK))','rho_quartz','density of quartz [kg/m^3]','omega','angular frequency [1/s]','c_CO2','diffusion coefficient [m^2/s]','c3_q','m^2/s','cp_quartz','specific heat for quartz  J/(kgK)','sigma','beam width [m]','c1_q','m^2/s','rho_CO2','density of air [kg/m^3]','cp_CO2','specific heat for air  J/(kgK)','K2_q','J/(m s K)','c11','N/m^2','c13','N/m^2','c12','N/m^2','K1_q','J/(m s K)','c14','N/m^2'};
fem.descr = descr;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

tic;
for it = 1:nrefT2
% Mapping stored solution to current extended mesh
u = asseminit(fem,'init',fem1.sol,'xmesh',fem1.xmesh,'blocksize','auto');
% fem=adaption(fem, ...
%              'u',u, ...
%              'solcomp',{'u2'}, ...
%              'outcomp',{'u','u2'}, ...
%              'blocksize','auto', ...
%              'solver','stationary', ...
%              'eigselect',1, ...
%              'maxt',10000000, ...
%              'ngen',1, ...
%              'rmethod','longest', ...
%              'resorder','auto', ...
%              'eefun','l2', ...
%              'l2scale',1, ...
%              'l2staborder',2, ...
%              'tppar',1.1, ...
%              'linsolver','gmres', ...
%              'itol',1.0E-8, ...
%              'maxlinit',100000, ...
%              'prefun','ssor', ...
%              'geomnum',1);
fem=adaption(fem, ...
             'u',u, ...             
             'solcomp',{'u2'}, ...
             'outcomp',{'u','u2'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',1, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.1, ...
             'linsolver','pardiso', ...
             'geomnum',1);

%fem1 = fem;

if (it == nrefD)
    fem2.mesh = fem.mesh;
end

end
tsec = toc;

% Store solution
fem1 = fem;

Pd =postint(fem,'I', ...
           'unit','1', ...
           'recover','off', ...
           'dl',2, ...
           'edim',2);    
       
E0 = postint(fem,'omega*rho_quartz*cp_quartz*u2', ...
           'unit','m', ...
           'recover','off', ...
           'dl',1);
       
Pi = abs(E0);

% obtain statistics about the mesh
filename = sprintf('statistics_T2.txt');
fid = fopen(filename, 'a+');
if (fid == -1)
  error('error opening log file');
end;
% obain mesh and FEM statistics:
N_e = size(fem.mesh.t,2); % number of mesh elements
N_p = size(fem.mesh.p,2); % number of points, i.e., vertices
ndofs = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented
fprintf(fid, '%9.6f %4d %7d %7d %7d %13.6e %13.6e %13.6e %7.2f \n', ...
     zs, nrefT2, N_e, N_p, ndofs, Pd, Pi, Pd/Pi,  tsec/60);
fclose(fid); 

%flsave T2 fem

%x = [0.15e-3:(0.4e-3- 0.15e-3)/100:0.4e-3];
%y = zeros(1, length(x));
%z = zs*ones(1, length(x));
%p = [x(:)';y(:)'; z(:)'];
%T21 = postinterp(fem, 'abs(u)', p);
%save data21 'x' 'T21'

%x = [0.15e-3:(0.4e-3- 0.15e-3)/100:0.4e-3];
%y = zeros(1, length(x));
%z = zs*ones(1, length(x));
%p = [x(:)';y(:)'; z(:)'];
%T2 = postinterp(fem, 'abs(u2)', p);
%save data3 'x' 'T2'

%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

% setup the mesh
fem.mesh = fem2.mesh;
      
flclear fem2 
        
% Application mode 1
clear appl
appl.mode.class = 'FlSolid3';
appl.dim = {'u4','v4','w4'};
appl.gporder = 4;
appl.cporder = 2;
appl.assignsuffix = '_sld';
clear prop
prop.analysis='eigen';
appl.prop = prop;
clear bnd
bnd.Hy = {0,1};
bnd.Hx = {0,1};
bnd.Hz = {0,1};
bnd.ind = [1,1,2,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;
fem.frame = {'ref'};

% Shape functions
fem.shape = {'shlag(2,''u4'')','shlag(2,''v4'')','shlag(2,''w4'')'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Subdomain settings
clear equ
equ.weak = '-ex_sld_test*sx_sld-ey_sld_test*sy_sld-ez_sld_test*sz_sld-2*exy_sld_test*sxy_sld-2*eyz_sld_test*syz_sld-2*exz_sld_test*sxz_sld-jomega_sld^2*rho_quartz*(u4_test*u4+v4_test*v4+w4_test*w4)';
equ.ind = [1];
equ.dim = {'u4','v4','w4'};
equ.var = {
  'sx_sld', 'c11*(ex_sld)+c12*(ey_sld)+c13*(ez_sld)+2*c14*eyz_sld', ...
  'sy_sld', 'c12*(ex_sld)+c11*(ey_sld)+c13*(ez_sld)-2*c14*eyz_sld', ...
  'sz_sld', 'c13*(ex_sld)+c13*(ey_sld)+c33*(ez_sld)', ...
  'syz_sld','c14*(ex_sld)-c14*(ey_sld)+2*c44*eyz_sld', ...
  'sxz_sld','2*(c44*exz_sld +c14*exy_sld)', ...
  'sxy_sld','2*(c14*exz_sld +c66*exy_sld)', ...
  'ex_sld','u4x', ...
  'ey_sld','v4y', ...
  'ez_sld','w4z', ...
  'exy_sld','0.5*(u4y+v4x)', ...
  'eyz_sld','0.5*(v4z+w4y)', ...
  'exz_sld','0.5*(u4z+w4x)'};

fem.equ = equ;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem, ...
  'sdl',[]);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
fem.sol=femeig(fem, ...
               'solcomp',{'w4','v4','u4'}, ...
               'outcomp',{'w4','v4','u4'}, ...
               'rowscale','off', ...
               'blocksize','auto', ...
               'neigs',4, ...
               'linsolver','spooles');

fem.sol      = asseminit(fem,'init',fem.sol,'solnum',[4]); 
fem.xmesh    = meshextend (fem);

N_e   = size(fem.mesh.t,2); % number of mesh elements
N_p   = size(fem.mesh.p,2); % number of points, i.e., vertices
ndofs = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented

absmaxu      = postmax(fem, 'abs(u4)');
absmaxv      = postmax(fem, 'abs(v4)');
absmaxw      = postmax(fem, 'abs(w4)');
eigf         = i*fem.sol.lambda/(2*pi);
omega_res    = 2*pi*eigf;

% Print the computed values:
fid = fopen('statistics_eigf.txt', 'a+');
if (fid == -1)
  error('error opening log file');
end;
%fprintf(fid, ' r       N       D        f      max(|u|)    max(|v|)     max(|w|)   time \n');
fprintf(fid, '%2d %7d %7d %7d %8.2f %12.4e %12.4e %12.4e %6.3f \n', ...
          0, N_e, N_p, ndofs, eigf,  absmaxu, absmaxv, absmaxw, 0);

%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% (Default values are not included)

% Constants
fem.const = {'omega','2*pi*33815.20', ...
  'omega_res', omega_res, ...
  'gamma','(omega/Q)*rho_quartz', ...
  'Q','39897',...
  'rho_quartz','2650', ...
  'c11','86.80e9', ...
  'c12','7.04e9', ...
  'c13','11.91e9', ...
  'c14','-18.04e9', ...
  'c33','105.75e9', ...
  'c44','58.20e9', ...
  'c66','39.88e9', ...
  'alpha1','13e-6', ...
  'alpha2','alpha1', ...
  'alpha3','8e-6'};

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'dir';
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'Helmholtz';
appl.dim = {'u2'};
appl.name = 'hzeq2';
appl.assignsuffix = '_hzeq2';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.r = {0,'u'};
bnd.type = 'dir';
bnd.ind = [1,2,1,2,2,2,2,2,2,2,1];
appl.bnd = bnd;
clear equ
equ.f = 0;
equ.c = {{{'c1_q';'c2_q';'c3_q'}}};
equ.a = 'i*omega';
equ.ind = [1];
appl.equ = equ;
fem.appl{2} = appl;

% Application mode 3
clear appl
appl.mode.class = 'FlSolid3';
appl.dim = {'u3','v3','w3'};
appl.gporder = 4;
appl.cporder = 2;
appl.assignsuffix = '_sld';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm3','lm4','lm5'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.Hy = {0,1};
bnd.Hx = {0,1};
bnd.Hz = {0,1};
bnd.ind = [1,1,2,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{3} = appl;
fem.frame = {'ref'};

% Shape functions
fem.shape = {'shlag(2,''u'')','shlag(2,''u2'')','shlag(2,''u3'')','shlag(2,''v3'')','shlag(2,''w3'')'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Subdomain settings
clear equ
% equ.f = {{1;0;1;1;1}};
% equ.c = {{1;{'c1_q';'c2_q';'c3_q'};1;1;1}};
% equ.a = {{1;'i*omega';1;1;1}};
equ.weak = {{0;0;'-ex_sld_test*sx_sld-ey_sld_test*sy_sld-ez_sld_test*sz_sld-2*exy_sld_test*sxy_sld-2*eyz_sld_test*syz_sld-2*exz_sld_test*sxz_sld+(rho_quartz*omega_res^2-i*omega_res*gamma)*(u3*u3_test+v3*v3_test+w3*w3_test)'}};
equ.ind = [1];
equ.dim = {'u','u2','u3','v3','w3'};
equ.var = {
  'sx_sld', 'c11*(ex_sld-alpha1*u2)+c12*(ey_sld-alpha2*u2)+c13*(ez_sld-alpha3*u2)+2*c14*eyz_sld', ...
  'sy_sld', 'c12*(ex_sld-alpha1*u2)+c11*(ey_sld-alpha2*u2)+c13*(ez_sld-alpha3*u2)-2*c14*eyz_sld', ...
  'sz_sld', 'c13*(ex_sld-alpha1*u2)+c13*(ey_sld-alpha2*u2)+c33*(ez_sld-alpha3*u2)', ...
  'syz_sld','c14*(ex_sld-alpha1*u2)-c14*(ey_sld-alpha2*u2)+2*c44*eyz_sld', ...
  'sxz_sld','2*(c44*exz_sld +c14*exy_sld)', ...
  'sxy_sld','2*(c14*exz_sld +c66*exy_sld)', ...
  'ex_sld','u3x', ...
  'ey_sld','v3y', ...
  'ez_sld','w3z', ...
  'exy_sld','0.5*(u3y+v3x)', ...
  'eyz_sld','0.5*(v3z+w3y)', ...
  'exz_sld','0.5*(u3z+w3x)'};
fem.equ = equ;

% Descriptions
clear descr
descr.const= {'c33','N/m^2','E','Youngs modulus [Pa]','c2_q','m^2/s','c44','N/m^2','K3_q','J/(m s K)','c66','N/m^2','mu','Poisson ratio','K_CO2','thermal conduction (W/(mK))','rho_quartz','density of quartz [kg/m^3]','omega','angular frequency [1/s]','c_CO2','diffusion coefficient [m^2/s]','c3_q','m^2/s','cp_quartz','specific heat for quartz  J/(kgK)','sigma','beam width [m]','c1_q','m^2/s','rho_CO2','density of air [kg/m^3]','cp_CO2','specific heat for air  J/(kgK)','K2_q','J/(m s K)','c11','N/m^2','c13','N/m^2','c12','N/m^2','K1_q','J/(m s K)','c14','N/m^2'};
fem.descr = descr;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem, ...
  'sdl',[]);

% Extend mesh
fem.xmesh=meshextend(fem);
tic;
%for it = 1:nrefD
% Mapping stored solution to current extended mesh
u = asseminit(fem,'init',fem1.sol,'xmesh',fem1.xmesh,'blocksize','auto');

flclear fem1 

% Solve problem
tic;
fem.sol=femstatic(fem, ...
                  'u',u, ...
                  'solcomp',{'v3','u3','w3'}, ...      
                  'outcomp',{'u','u2','v3','u3','w3'}, ...
                  'blocksize','auto', ...
                  'linsolver','spooles');                    
tsec = toc;

% Integrate to compute the maximum displacement
realu =postint(fem,'real(u3)', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);

imagu =postint(fem,'imag(u3)', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);

ampu =  postint(fem,'abs(u3)', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);

thetau = postint(fem,'atan2(imag(u3), real(u3)) * 180/pi', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);


N_e   = size(fem.mesh.t,2); % number of mesh elements
N_p   = size(fem.mesh.p,2); % number of points, i.e., vertices
ndofs = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented
eigf         = 0;

% Print the computed values:
fid = fopen('statistics_displ.txt', 'a+');
if (fid == -1)
  error('error opening log file');
end;
fprintf(fid, '%9.6f %9.6f %4d %7d %7d %7d %23.16e %23.16e %23.16e %7.2f %7.2f\n', ...
     xs, zs, nrefD, N_e, N_p, ndofs, realu, imagu , ampu , thetau , tsec/60);
fclose(fid); 

%x = [0.15e-3:(0.4e-3-0.15e-3)/100:0.4e-3];
%y = zeros(1, length(x));
%z = zs*ones(1, length(x));
%p = [x(:)';y(:)'; z(:)'];
%TD = postinterp(fem, 'abs(u2)', p);
%save data4 'x' 'TD'

end