clc; clear all; close all;

flload('temperature2D_boundarydata.mph');
p = fem.mesh.p;
realT           = postinterp(fem, 'real(u)', p);
imagT           = postinterp(fem, 'imag(u)', p);

x = p(1,:);
y = (5e-4)*ones(1, length(x));
z = p(2,:);

fid1 = fopen('realT.txt', 'w');
if (fid1 == -1)
  error('error opening log file');
end;
fprintf(fid1, '%23s %23s %23s %23s\n', 'x', 'y', 'z', 'realT');
for it = 1:length(x)
fprintf(fid1, '%23.16f %23.16f %23.16f %23.16e\n', x(it), y(it), z(it), realT(it));
end

fid2 = fopen('imagT.txt', 'w');
if (fid2 == -1)
  error('error opening log file');
end;
fprintf(fid2, '%23s %23s %23s %23s\n', 'x', 'y', 'z', 'imagT');
for it = 1:length(x)
fprintf(fid2, '%23.16f %23.16f %23.16f %23.16e\n', x(it), y(it), z(it), imagT(it));
end

%save 'dataT_newreduced' 'x' 'y' 'z' 'realT' 'imagT'
save 'boundarydata' 'x' 'y' 'z' 'realT' 'imagT'

clear fem