% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.603, $Date: 2008/12/03 17:02:19 $)

flclear fem

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 603;
vrsn.rcs = '$Name:  $';
vrsn.date = '$Date: 2008/12/03 17:02:19 $';
fem.version = vrsn;

% Geometry
% Import CAD data
garr = geomimport('D:\Work\COMSOL_work\rotade5_ChristmasWork\ver0.2rotade_symmetrytest\boundary_data\2Dreduced.mphbin', ...
                  'repairtol','1.0E-5');
[g1]=deal(garr{:});

% Constants
fem.const = {'omega','2*pi*32785.47', ...
  'xs',0, ...
  'ys',0, ...
  'zs',0, ...
  'rho_quartz','2650', ...
  'cp_quartz','733', ...
  'rho_CO2','0.047850', ...
  'cp_CO2','0.84081e3', ...
  'K_CO2','0.016346', ...
  'c_CO2','K_CO2/(rho_CO2*cp_CO2)', ...
  'K1_q','6.5', ...
  'K2_q','6.5', ...
  'K3_q','11.3', ...
  'c1_q','K1_q/(rho_quartz*cp_quartz)', ...
  'c2_q','K2_q/(rho_quartz*cp_quartz)', ...
  'c3_q','K3_q/(rho_quartz*cp_quartz)', ...
  'w0','7.5e-6', ...
  'lam','1.55e-6', ...                        
  'W_L', '30e-3',...
  'yfront','5e-4'};      

fem.globalexpr = {'yR','pi*w0^2/lam', ...
  'wy','w0*sqrt(1+(yfront/yR)^2)', ...
  'A_CO2p','(1/(rho_CO2*cp_CO2))*(2*W_L/pi)', ...        %!!! this does not inlcude the abs coeff
  'source_CO2','(A_CO2p/wy^2)*exp(-2*((x-xs)^2+(y-zs)^2)/wy^2)'};

% Geometry

% Analyzed geometry
clear s
s.objs={g1};
s.name={'CO1'};
s.tags={'g1'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',5);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.sshape = 2;
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'dir';
bnd.ind = [1,1,1,1];
appl.bnd = bnd;
clear equ
equ.f = 'source_CO2';
equ.c = 'c_CO2';
equ.a = 'i*omega';
equ.ind = [1];
appl.equ = equ;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Descriptions
clear descr
descr.const= {'E','Youngs modulus [Pa]','c33','N/m^2','c44','N/m^2','z0','source position [m]','c66','N/m^2','K_CO2','thermal conduction (W/(mK))','mu','Poisson ratio','rho_quartz','density of quartz [kg/m^3]','c_CO2','diffusion coefficient [m^2/s]','omega','angular frequency [1/s]','sigma','beam width [m]','cp_CO2','specific heat for air  J/(kgK)','rho_CO2','density of air [kg/m^3]','c11','N/m^2','c13','N/m^2','c12','N/m^2','c14','N/m^2'};
fem.descr = descr;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
fem=adaption(fem, ...
             'solcomp',{'u'}, ...
             'outcomp',{'u'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',6, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.7, ...
             'linsolver','pardiso', ...
             'geomnum',1);

% % Save current fem structure for restart purposes
% fem0=fem;

% %Plot in cross-section or along domain
% postcrossplot(fem,1,[0 0.4e-3;0 0], ...
%               'lindata','abs(u)', ...
%               'linxdata','x', ...
%               'title','abs(u)', ...
%               'axislabel',{'x','abs(u)'});

flsave('temperature2D_boundarydata.mph', fem);