% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.608, $Date: 2009/05/11 07:38:49 $)
function [Pd, Pi, epskappa ] = rotade3Ds_epskappa(xs, ys, zs, nrefT1, nrefT2, SCALE, l, lb, w, t, w0, yR, f)

flreport('off');
fclose('all');

if (exist('fem0','var')), clear fem0 ; end;
if (exist('fem1','var')), clear fem1 ; end;
if (exist('fem2','var')), clear fem2 ; end;
if (exist('fem','var')),  clear fem ; end;
if (exist('femtemp','var')),  clear femtemp; end;

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 608;
vrsn.rcs = '$Name: v35ap $';
vrsn.date = '$Date: 2009/05/11 07:38:49 $';
fem.version = vrsn;

fem.const = {'omega',2*pi*f, ...
  'xs',xs, ...
  'ys',ys, ...
  'zs',zs, ...
  'l',l,...
  'radius','0.5', ...
  'lt','l+radius+lb', ...
  'lb', lb,...
  'width',w, ...
  'gap','1', ...
  'thickness',t, ...
  'rho_quartz','2650', ...
  'cp_quartz','733', ...
  'rho_CO2','0.047850', ...
  'cp_CO2','840.81', ...
  'K_CO2','0.016346', ...
  'c_CO2','K_CO2/(rho_CO2*cp_CO2)', ...
  'K1_q','6.5', ...
  'K2_q','6.5', ...
  'K3_q','11.3', ...
  'c1_q','K1_q/(rho_quartz*cp_quartz)', ...
  'c2_q','K2_q/(rho_quartz*cp_quartz)', ...
  'c3_q','K3_q/(rho_quartz*cp_quartz)', ...
  'w0',w0, ...
  'yR',yR,...
  'lam','1.55e-6', ...
  'W_L','50e-3', ...
  'c11','86.80e9', ...
  'c12','7.04e9', ...
  'c13','11.91e9', ...
  'c14','-18.04e9', ...
  'c33','105.75e9', ...
  'c44','58.20e9', ...
  'c66','39.88e9', ...
  'alpha1','13*(10^-6)', ...
  'alpha2','alpha1', ...
  'alpha3','8*(10^-6)',...
  'SCALE', SCALE};

% Global expressions
fem.globalexpr = {'wy','w0*sqrt(1+(y/yR)^2)', ...
  'A_CO2p','(1/(rho_CO2*cp_CO2))*(2*W_L/pi)', ...
  'A_qzp','(1/(rho_quartz*cp_quartz))*(2*W_L/pi)', ...
  'source_CO2','(A_CO2p/wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)', ...
  'source_qz','(A_qzp/wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)',...
  'I','2*W_L/(pi*wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)'};

% Geometry
g1=block3('2*width+gap','thickness','lt','base','center','pos',{'0','0','l-lt/2'},'axis',{'0','0','1'},'rot','0','const',fem.const);
g2=block3('gap','thickness','l','base','center','pos',{'0','0','l/2'},'axis',{'0','0','1'},'rot','0','const',fem.const);
g3=cylinder3('0.5','thickness','pos',{'0','-thickness/2','0'},'axis',{'0','1','0'},'rot','0','const',fem.const);
g4=geomcomp({g2,g3},'ns',{'BLK2','CYL1'},'sf','BLK2+CYL1','face','all','edge','all');
g5=geomcomp({g1,g4},'ns',{'BLK1','CO1'},'sf','BLK1-CO1','face','all','edge','all');
g6=block3('(2*width+gap)*(1+1/5)','thickness*2','lt*(1+1/10)','base','center','pos',{'0','0','l-lt/2'},'axis',{'0','0','1'},'rot','0','const',fem.const);
g7=geomcomp({g5,g6},'ns',{'CO2','BLK1'},'sf','CO2+BLK1','face','none','edge','all');

% Analyzed geometry
clear s
s.objs={g7};
s.name={'CO1'};
s.tags={'g7'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',5);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.sshape = 2;
appl.assignsuffix = '_hzeq';
clear bnd
bnd.r = {0,'boundaryT_SCALEDeq(x-xs,z-zs)'};
bnd.type = 'dir';
bnd.ind = [1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
clear equ
equ.f = {'source_CO2','source_qz'};
equ.c = {'c_CO2',{{'c1_q';'c2_q';'c3_q'}}};
equ.a = 'i*omega*SCALE^2';
equ.ind = [1,2];
appl.equ = equ;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
tic;
fem=adaption(fem, ...
             'solcomp',{'u'}, ...
             'outcomp',{'u'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',nrefT1, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.1, ...
             'linsolver','gmres', ...
             'prefun','ssor', ...
             'geomnum',1);
tsec = toc;

% Save current fem structure for restart purposes
fem1=fem;

% -------------------------- heat problem 2 -------------------------------
% Analyzed geometry
clear s
s.objs={g5};
s.name={'CO2'};
s.tags={'g5'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',1);
              
% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'dir';
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'Helmholtz';
appl.dim = {'u2'};
appl.name = 'hzeq2';
appl.sshape = 2;
appl.assignsuffix = '_hzeq2';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.r = {0,'u'};
bnd.type = 'dir';
bnd.ind = [1,2,1,2,2,2,2,2,2,2,1];
appl.bnd = bnd;
clear equ
equ.f = 'source_qz';
equ.c = {{{'c1_q';'c2_q';'c3_q'}}};
equ.a = 'i*omega*SCALE^2';
equ.ind = [1];
appl.equ = equ;
fem.appl{2} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);
          
tic;
for it = 1:nrefT2
% Mapping stored solution to current extended mesh
u = asseminit(fem,'init',fem1.sol,'xmesh',fem1.xmesh,'blocksize','auto');
fem=adaption(fem, ...
             'u',u, ...
             'solcomp',{'u2'}, ...
             'outcomp',{'u','u2'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',1, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.1, ...
             'linsolver','gmres', ...
             'itol',1.0E-8, ...
             'maxlinit',100000, ...
             'prefun','ssor', ...
             'geomnum',1);
end
tsec = toc;

flclear fem1;

Pd =postint(fem,'I', ...
           'unit','1', ...
           'recover','off', ...
           'dl',2, ...
           'edim',2);    
       
E0 = postint(fem,'omega*rho_quartz*cp_quartz*u2', ...
           'unit','m', ...
           'recover','off', ...
           'dl',1);
       
Pi = abs(E0);

epskappa = Pd/Pi;

fIDs = fopen('all');
fprintf('testing the print out! length(fIDs) = %2d \n', length(fIDs));

end