% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.603, $Date: 2008/12/03 17:02:19 $)

function out = T2D_boundarydata_SCALEDeq(SCALE, w, t, w0, yR, f)

%flreport('off');
if (exist('fem','var')),  clear fem ; end;

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 603;
vrsn.rcs = '$Name:  $';
vrsn.date = '$Date: 2008/12/03 17:02:19 $';
fem.version = vrsn;

% Constants
fem.const = {'omega',2*pi*f, ...
  'xs',0, ...
  'ys',0, ...
  'zs',0, ...
  'gap','1', ...
  'width',w,...
  'thickness',t, ...
   'rho_CO2','0.047664', ...
  'cp_CO2','841.92', ...
  'K_CO2','0.016438', ...
  'c_CO2','K_CO2/(rho_CO2*cp_CO2)', ...
  'w0',w0, ...
  'yR',yR,...
  'lam','1.55e-6', ...
  'W_L','50e-3', ...
  'yfront','(thickness*3)/2',...
  'SCALE', SCALE};    

% Geometry
g1=square2('2*width+gap','base','center','pos',{'0','0'},'rot','0','const',fem.const);

% Analyzed geometry
clear s
s.objs={g1};
s.name={'SQ1'};
s.tags={'g1'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

fem.globalexpr = {'wy','w0*sqrt(1+(yfront/yR)^2)', ...             !!!% yfront - not scaled since it is scaled in the constants
  'A_CO2p','(1/(rho_CO2*cp_CO2))*(2*W_L/pi)', ...        %!!! this does not inlcude the abs coeff
  'source_CO2','(A_CO2p/wy^2)*exp(-2*((x-xs)^2+(y-zs)^2)/wy^2)'};

% Geometry
% Analyzed geometry
clear s
s.objs={g1};
s.name={'CO1'};
s.tags={'g1'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',5);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.sshape = 2;
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'dir';
bnd.ind = [1,1,1,1];
appl.bnd = bnd;
clear equ
equ.f = 'source_CO2';
equ.c = 'c_CO2';
equ.a = 'i*omega*SCALE^2';
equ.ind = [1];
appl.equ = equ;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Descriptions
clear descr
descr.const= {'E','Youngs modulus [Pa]','c33','N/m^2','c44','N/m^2','z0','source position [m]','c66','N/m^2','K_CO2','thermal conduction (W/(mK))','mu','Poisson ratio','rho_quartz','density of quartz [kg/m^3]','c_CO2','diffusion coefficient [m^2/s]','omega','angular frequency [1/s]','sigma','beam width [m]','cp_CO2','specific heat for CO2  J/(kgK)','rho_CO2','density of CO2 [kg/m^3]','c11','N/m^2','c13','N/m^2','c12','N/m^2','c14','N/m^2'};
fem.descr = descr;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
tic;
fem=adaption(fem, ...
             'solcomp',{'u'}, ...
             'outcomp',{'u'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',6, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.7, ...
             'linsolver','pardiso', ...
             'geomnum',1);
tsec = toc;
maxT = postmax(fem,'abs(u)');
% obtain statistics about the mesh
%filename = sprintf('statistics_bdyT.txt');
%fidstatistics_bdyT = fopen(filename, 'a+');
%if (fidstatistics_bdyT == -1)
%  error('error opening log file');
%end;
%fprintf(fidstatistics_bdyT, '%9.6f %13.6e %7.2f %s\n', ...
%     SCALE, maxT,  tsec/60, 'bdyT - scaled equation');
%fclose(fidstatistics_bdyT); 
%flsave('T2D_bddydata_SCALEDeq.mph', fem);

% save the boundary data
p = fem.mesh.p;
realT           = postinterp(fem, 'real(u)', p);
imagT           = postinterp(fem, 'imag(u)', p);
x = p(1,:);
z = p(2,:);
save 'boundarydata_SCALEDeq' 'x' 'z' 'realT' 'imagT'
clear p x z realT imagT

out = 0;
end