% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.608, $Date: 2009/05/11 07:38:49 $)
function [ realu, imagu , ampu , thetau] = rotade3D_SCALEDeq(xs, ys, zs, nrefT1, nrefT2, nrefD, nreigs, SCALE, l, lb, w, t, w0, yR, f)

%flreport('off');

if (exist('fem0','var')), clear fem0 ; end;
if (exist('fem1','var')), clear fem1 ; end;
if (exist('fem2','var')), clear fem2 ; end;
if (exist('fem','var')),  clear fem ; end;
if (exist('femtemp','var')), clear femtemp; end;

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 608;
vrsn.rcs = '$Name: v35ap $';
vrsn.date = '$Date: 2009/05/11 07:38:49 $';
fem.version = vrsn;

fem.const = {'omega',2*pi*f, ...
  'xs',xs, ...
  'ys',ys, ...
  'zs',zs, ...
  'l',l,...
  'radius','0.5', ...
  'lt','l+radius+lb', ...
  'lb', lb,...
  'width',w, ...
  'gap','1', ...
  'thickness',t, ...
  'rho_quartz','2650', ...
  'cp_quartz','733', ...
  'rho_CO2','0.022752', ...
  'cp_CO2','1039.7', ...
  'K_CO2','0.025570', ...
  'c_CO2','K_CO2/(rho_CO2*cp_CO2)', ...
  'K1_q','6.5', ...
  'K2_q','6.5', ...
  'K3_q','11.3', ...
  'c1_q','K1_q/(rho_quartz*cp_quartz)', ...
  'c2_q','K2_q/(rho_quartz*cp_quartz)', ...
  'c3_q','K3_q/(rho_quartz*cp_quartz)', ...
  'w0',w0, ...
  'yR',yR,...
  'lam','1.55e-6', ...
  'W_L','50e-3', ...
  'c11','86.80e9', ...
  'c12','7.04e9', ...
  'c13','11.91e9', ...
  'c14','-18.04e9', ...
  'c33','105.75e9', ...
  'c44','58.20e9', ...
  'c66','39.88e9', ...
  'alpha1','13*(10^-6)', ...
  'alpha2','alpha1', ...
  'alpha3','8*(10^-6)',...
  'SCALE', SCALE};

% Global expressions
fem.globalexpr = {'wy','w0*sqrt(1+(y/yR)^2)', ...
  'A_CO2p','(1/(rho_CO2*cp_CO2))*(2*W_L/pi)', ...
  'A_qzp','(1/(rho_quartz*cp_quartz))*(2*W_L/pi)', ...
  'source_CO2','(A_CO2p/wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)', ...
  'source_qz','(A_qzp/wy^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)',...
  'I','2*W_L/(pi*wy^2*SCALE^2)*exp(-2*((x-xs)^2+(z-zs)^2)/wy^2)'};

% Geometry
g1=block3('2*width+gap','thickness','lt','base','center','pos',{'0','0','l-lt/2'},'axis',{'0','0','1'},'rot','0','const',fem.const);
g2=block3('gap','thickness','l','base','center','pos',{'0','0','l/2'},'axis',{'0','0','1'},'rot','0','const',fem.const);
g3=cylinder3('0.5','thickness','pos',{'0','-thickness/2','0'},'axis',{'0','1','0'},'rot','0','const',fem.const);
g4=geomcomp({g2,g3},'ns',{'BLK2','CYL1'},'sf','BLK2+CYL1','face','all','edge','all');
g5=geomcomp({g1,g4},'ns',{'BLK1','CO1'},'sf','BLK1-CO1','face','all','edge','all');
g6=block3('(2*width+gap)*(2)','thickness*3','lt*(1+1/10)','base','center','pos',{'0','0','l-lt/2'},'axis',{'0','0','1'},'rot','0','const',fem.const);
g7=geomcomp({g5,g6},'ns',{'CO2','BLK1'},'sf','CO2+BLK1','face','none','edge','all');

% Analyzed geometry
clear s
s.objs={g7};
s.name={'CO1'};
s.tags={'g7'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',5);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.sshape = 2;
appl.assignsuffix = '_hzeq';
clear bnd
bnd.r = {0,'boundaryT_SCALEDeq(x-xs,z-zs)'};
bnd.type = 'dir';
bnd.ind = [1,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
clear equ
equ.f = {'source_CO2','source_qz'};
equ.c = {'c_CO2',{{'c1_q';'c2_q';'c3_q'}}};
equ.a = 'i*omega*SCALE^2';
equ.ind = [1,2];
appl.equ = equ;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
tic;
fem=adaption(fem, ...
             'solcomp',{'u'}, ...
             'outcomp',{'u'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',nrefT1, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.1, ...
             'linsolver','pardiso', ...
             'geomnum',1);
tsecT1 = toc;

% Save current fem structure for restart purposes
fem1=fem;

% obain mesh and FEM statistics:
ndofsT1 = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented

% -------------------------- heat problem 2 -------------------------------
% Analyzed geometry
clear s
s.objs={g5};
s.name={'CO2'};
s.tags={'g5'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Initialize mesh
fem.mesh=meshinit(fem, ...
                  'hauto',3);
              
% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'dir';
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'Helmholtz';
appl.dim = {'u2'};
appl.name = 'hzeq2';
appl.sshape = 2;
appl.assignsuffix = '_hzeq2';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.r = {0,'u'};
bnd.type = 'dir';
bnd.ind = [1,2,1,2,2,2,2,2,2,2,1];
appl.bnd = bnd;
clear equ
equ.f = 'source_qz';
equ.c = {{{'c1_q';'c2_q';'c3_q'}}};
equ.a = 'i*omega*SCALE^2';
equ.ind = [1];
appl.equ = equ;
fem.appl{2} = appl;
fem.frame = {'ref'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);
          
tic;
for it = 1:nrefT2
% Mapping stored solution to current extended mesh
u = asseminit(fem,'init',fem1.sol,'xmesh',fem1.xmesh,'blocksize','auto');
fem=adaption(fem, ...
             'u',u, ...
             'solcomp',{'u2'}, ...
             'outcomp',{'u','u2'}, ...
             'blocksize','auto', ...
             'solver','stationary', ...
             'eigselect',1, ...
             'maxt',10000000, ...
             'ngen',1, ...
             'rmethod','longest', ...
             'resorder','auto', ...
             'eefun','l2', ...
             'l2scale',1, ...
             'l2staborder',2, ...
             'tppar',1.1, ...
             'linsolver','pardiso', ...
             'geomnum',1);
if (it == nrefD)
    femtemp.mesh = fem.mesh;
end

end
ndofsT2 = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented

tsecT2 = toc;

flclear fem1;
% Store solution T2
fem2 = fem;

Pd =postint(fem,'I', ...
           'unit','1', ...
           'recover','off', ...
           'dl',2, ...
           'edim',2);    
       
E0 = postint(fem,'omega*rho_quartz*cp_quartz*u2', ...
           'unit','m', ...
           'recover','off', ...
           'dl',1);
       
Pd = Pd*SCALE^2;       
Pi = abs(E0)*SCALE^3;

if Pi < eps
	epskappa = 0;
else
	epskappa = Pd/Pi;
end

% ----------------------- EVP --------------------------------------------
% setup the mesh
fem.mesh = femtemp.mesh;
flclear femtemp;
  
% Application mode 1
clear appl
appl.mode.class = 'FlSolid3';
appl.dim = {'u4','v4','w4'};
appl.gporder = 4;
appl.cporder = 2;
appl.assignsuffix = '_sld';
clear prop
prop.analysis='eigen';
appl.prop = prop;
clear bnd
bnd.Hy = {0,1};
bnd.Hx = {0,1};
bnd.Hz = {0,1};
bnd.ind = [1,1,2,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;
fem.frame = {'ref'};

% Shape functions
fem.shape = {'shlag(2,''u4'')','shlag(2,''v4'')','shlag(2,''w4'')'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Subdomain settings
clear equ
equ.weak = '-ex_sld_test*sx_sld-ey_sld_test*sy_sld-ez_sld_test*sz_sld-2*exy_sld_test*sxy_sld-2*eyz_sld_test*syz_sld-2*exz_sld_test*sxz_sld-(SCALE^2)*jomega_sld^2*rho_quartz*(u4_test*u4+v4_test*v4+w4_test*w4)';
equ.ind = [1];
equ.dim = {'u4','v4','w4'};
equ.var = {
  'sx_sld', 'c11*(ex_sld)+c12*(ey_sld)+c13*(ez_sld)+2*c14*eyz_sld', ...
  'sy_sld', 'c12*(ex_sld)+c11*(ey_sld)+c13*(ez_sld)-2*c14*eyz_sld', ...
  'sz_sld', 'c13*(ex_sld)+c13*(ey_sld)+c33*(ez_sld)', ...
  'syz_sld','c14*(ex_sld)-c14*(ey_sld)+2*c44*eyz_sld', ...
  'sxz_sld','2*(c44*exz_sld +c14*exy_sld)', ...
  'sxy_sld','2*(c14*exz_sld +c66*exy_sld)', ...
  'ex_sld','u4x', ...
  'ey_sld','v4y', ...
  'ez_sld','w4z', ...
  'exy_sld','0.5*(u4y+v4x)', ...
  'eyz_sld','0.5*(v4z+w4y)', ...
  'exz_sld','0.5*(u4z+w4x)'};
fem.equ = equ;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem, ...
  'sdl',[]);

% Extend mesh
fem.xmesh=meshextend(fem);

tic;
% Solve problem
fem.sol=femeig(fem, ...
               'solcomp',{'w4','v4','u4'}, ...
               'outcomp',{'w4','v4','u4'}, ...
               'rowscale','off', ...
               'blocksize','auto', ...
               'neigs',nreigs, ...
               'linsolver','spooles');
tseceig = toc;
% Print the computed values:
% fidselect_emode = fopen('select_emode.txt', 'a+');
% if (fidselect_emode == -1)
%   error('error opening log file');
% end;
eigf = 0;
for it = 1:nreigs
% Integrate
u_L = postint(fem,'(u4)', ...
           'unit','m', ...
           'recover','off', ...
           'dl',6, ...
           'edim',0, ...
           'solnum',it);
u_R = postint(fem,'(u4)', ...
           'unit','m', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0, ...
           'solnum',it);
       
v_L = postint(fem,'(v4)', ...
           'unit','m', ...
           'recover','off', ...
           'dl',6, ...
           'edim',0, ...
           'solnum',it);
v_R = postint(fem,'(v4)', ...
           'unit','m', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0, ...
           'solnum',it);
w_L = postint(fem,'(w4)', ...
           'unit','m', ...
           'recover','off', ...
           'dl',6, ...
           'edim',0, ...
           'solnum',it);
w_R = postint(fem,'(w4)', ...
           'unit','m', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0, ...
           'solnum',it);
% fprintf(fidselect_emode, '%2d %7.4f %8.2f %6.3f %6.3f %11.2e %6.3f %6.3f %11.2e %11.2e %6.3f %6.3f %11.2e\n', ...
%           it, SCALE, i*fem.sol.lambda(it)/(2*pi),u_L, u_R,abs(u_L+u_R), v_L, v_R, ...
%           abs(abs(u_L)/abs(v_L)), abs(abs(u_R)/abs(v_R)), w_L, w_R , abs(abs(u_L)/abs(w_L)));      

if ( abs(u_L+u_R) < 1e-1 && ...
   ((abs(abs(u_L)/abs(v_L))> 1.5) || abs(abs(u_R)/abs(v_R))> 1.5) && ...
   ((abs(abs(u_L)/abs(w_L))> 1.5) || abs(abs(u_R)/abs(w_R))> 1.5) )
    %fprintf(fidselect_emode, 'Found antysymmetric mode!!! f = %8.2f\n', i*fem.sol.lambda(it)/(2*pi));
    eigf = i*fem.sol.lambda(it)/(2*pi);

    %fem.sol      = asseminit(fem,'init',fem.sol,'solnum',it); 
    fem.xmesh    = meshextend (fem);

    absmaxu      = postmax(fem, 'abs(u4)');
    absmaxv      = postmax(fem, 'abs(v4)');
    absmaxw      = postmax(fem, 'abs(w4)');

    N_e   = size(fem.mesh.t,2); % number of mesh elements
    N_p   = size(fem.mesh.p,2); % number of points, i.e., vertices
    ndofs = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented

% % Print the computed values:
%     fid1 = fopen('statistics_eigf.txt', 'a+');
%     if (fid1 == -1)
%       error('error opening log file');
%     end;
%     %fprintf(fid1, ' r       N       D        f      max(|u|)    max(|v|)     max(|w|)   time \n');
%     fprintf(fid1, '%2d %7d %7d %7d %8.2f %12.4e %12.4e %12.4e %s \n', ...
%               0, N_e, N_p, ndofs, eigf,  absmaxu, absmaxv, absmaxw, 'SCALED equation - EVP deform');
%     fclose(fid1); 
end
end

% if (eigf == 0)
%     % Print the computed values:
%     fid2 = fopen('statistics_eigf.txt', 'a+');
%     if (fid2 == -1)
%       error('error opening log file');
%     end;
%     %fprintf(fid, ' r       N       D        f      max(|u|)    max(|v|)     max(|w|)   time \n');
% %     fprintf(fid2, '%2d %7d %7d %7d %8.2f %12.4e %12.4e %12.4e %s \n', ...
% %               0, N_e, N_p, ndofs, eigf,  absmaxu, absmaxv, absmaxw, 'SCALED equation - EVP deform');
%     fprintf(fid2,'Warning:: resonance frequency NOT found! for SCALE = %d, l = %7.5f, w = %7.5f, t = %7.5f\n', SCALE, l, w, t);
%     fclose(fid2);
% end
%fprintf(fidselect_emode, '%s\n', '----------------------------------------------------');
%fclose(fidselect_emode);

omega_res    = 2*pi*eigf;

fprintf('eigf_res = %8.2f\n', eigf);

%--------------------------------------------------------------------------
%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% DISPLACEMENT PROBLEM

% Constants
fem.const = {'omega_res', omega_res, ...
  'gamma','(omega_res/Q)*rho_quartz', ...
  'Q','46069',...
  'xs',xs, ...
  'ys',ys, ...
  'zs',zs, ...
  'rho_quartz','2650', ...
  'c11','86.80e9', ...
  'c12','7.04e9', ...
  'c13','11.91e9', ...
  'c14','-18.04e9', ...
  'c33','105.75e9', ...
  'c44','58.20e9', ...
  'c66','39.88e9', ...
  'alpha1','13*(10^-6)', ...
  'alpha2','alpha1', ...
  'alpha3','8*(10^-6)',...
  'SCALE', SCALE};

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'dir';
bnd.ind = [1,1,1,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'Helmholtz';
appl.dim = {'u2'};
appl.name = 'hzeq2';
appl.assignsuffix = '_hzeq2';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.r = {0,'u'};
bnd.type = 'dir';
bnd.ind = [1,2,1,2,2,2,2,2,2,2,1];
appl.bnd = bnd;
clear equ
equ.f = 0;
equ.c = {{{'c1_q';'c2_q';'c3_q'}}};
equ.a = 'i*omega';
equ.ind = [1];
appl.equ = equ;
fem.appl{2} = appl;

% Application mode 3
clear appl
appl.mode.class = 'FlSolid3';
appl.dim = {'u3','v3','w3'};
appl.gporder = 4;
appl.cporder = 2;
appl.assignsuffix = '_sld';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm3','lm4','lm5'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.Hy = {0,1};
bnd.Hx = {0,1};
bnd.Hz = {0,1};
bnd.ind = [1,1,2,1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{3} = appl;
fem.frame = {'ref'};

% Shape functions
fem.shape = {'shlag(2,''u'')','shlag(2,''u2'')','shlag(2,''u3'')','shlag(2,''v3'')','shlag(2,''w3'')'};
fem.border = 1;
clear units;
units.basesystem = 'SI';
fem.units = units;

% Subdomain settings
clear equ
% equ.f = {{1;0;1;1;1}};
% equ.c = {{1;{'c1_q';'c2_q';'c3_q'};1;1;1}};
% equ.a = {{1;'i*omega';1;1;1}};
equ.weak = {{0;0;'-ex_sld_test*sx_sld-ey_sld_test*sy_sld-ez_sld_test*sz_sld-2*exy_sld_test*sxy_sld-2*eyz_sld_test*syz_sld-2*exz_sld_test*sxz_sld+(SCALE^2)*(rho_quartz*omega_res^2-i*omega_res*gamma)*(u3*u3_test+v3*v3_test+w3*w3_test)'}};
equ.ind = [1];
equ.dim = {'u','u2','u3','v3','w3'};
equ.var = {
  'sx_sld', 'c11*(ex_sld-(SCALE)*alpha1*u2)+c12*(ey_sld-(SCALE)*alpha2*u2)+c13*(ez_sld-(SCALE)*alpha3*u2)+2*c14*eyz_sld', ...
  'sy_sld', 'c12*(ex_sld-(SCALE)*alpha1*u2)+c11*(ey_sld-(SCALE)*alpha2*u2)+c13*(ez_sld-(SCALE)*alpha3*u2)-2*c14*eyz_sld', ...
  'sz_sld', 'c13*(ex_sld-(SCALE)*alpha1*u2)+c13*(ey_sld-(SCALE)*alpha2*u2)+c33*(ez_sld-(SCALE)*alpha3*u2)', ...
  'syz_sld','c14*(ex_sld-(SCALE)*alpha1*u2)-c14*(ey_sld-(SCALE)*alpha2*u2)+2*c44*eyz_sld', ...
  'sxz_sld','2*(c44*exz_sld +c14*exy_sld)', ...
  'sxy_sld','2*(c14*exz_sld +c66*exy_sld)', ...
  'ex_sld','u3x', ...
  'ey_sld','v3y', ...
  'ez_sld','w3z', ...
  'exy_sld','0.5*(u3y+v3x)', ...
  'eyz_sld','0.5*(v3z+w3y)', ...
  'exz_sld','0.5*(u3z+w3x)'};
fem.equ = equ;

% ODE Settings
clear ode
clear units;
units.basesystem = 'SI';
ode.units = units;
fem.ode=ode;

% Multiphysics
fem=multiphysics(fem, ...
  'sdl',[]);

% Extend mesh
fem.xmesh=meshextend(fem);

%for it = 1:nrefD
% Mapping stored solution to current extended mesh
u = asseminit(fem,'init',fem2.sol,'xmesh',fem2.xmesh,'blocksize','auto');

% Solve problem
tic;
fem.sol=femstatic(fem, ...
                  'u',u, ...
                  'solcomp',{'v3','u3','w3'}, ...      
                  'outcomp',{'u','u2','v3','u3','w3'}, ...
                  'blocksize','auto', ...
                  'linsolver','spooles');        
tsecD = toc;            
flclear fem2 

% Integrate to compute the maximum displacement
realu =postint(fem,'real(u3)', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);

imagu =postint(fem,'imag(u3)', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);

ampu =  postint(fem,'abs(u3)', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);

if (imagu == 0)
	thetau = 0;
else
	thetau = postint(fem,'atan2(imag(u3), real(u3)) * 180/pi', ...
           'unit','m^2', ...
           'recover','off', ...
           'dl',12, ...
           'edim',0);
end

ndofsD = xmeshinfo(fem, 'out','ndofs'); % DOFs directly, as documented

tsec = tsecT1+tsecT2+tseceig+tsecD;

% Print the computed values:
fidstatistics_displ = fopen('statistics_displ.txt', 'a+');
if (fidstatistics_displ == -1)
   error('error opening log file');
end;
fprintf(fidstatistics_displ, '%10.8f %8.5f %23.16e %23.16e %23.16e %6.2f %4d %7d %7d %7d %7.2f\n', ...
     SCALE*zs, eigf, realu, imagu, ampu, thetau, nrefD, ndofsT1, ndofsT2, ndofsD, tsec/60);
fclose(fidstatistics_displ); 

fIDs = fopen('all');
if (fIDs ~= 0)
	fprintf('testing the print out! length(fIDs) = %2d \n', length(fIDs));
end

end